package com.link.core.basic.service.snowflake;

import com.link.core.cllog.LCLogger;
import com.link.core.util.RedisUtil;
import com.link.core.util.redisclient.LinkRedisClient;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class RedisSequenceUtil {
   private static final String LUA_SCRIPT = "local key = KEYS[1]\nlocal expire_time = tonumber(ARGV[1])\nlocal is_exists = redis.call(\"EXISTS\", key)\nif is_exists == 1 then\n\tlocal next = tonumber(redis.call(\"INCR\", key))\n\treturn next\nelse\n\tredis.call(\"SET\", key, 1)\n\tredis.call(\"EXPIRE\", key, expire_time)\n\treturn 1\nend";

   public static Long getSequence(String key, int expireSeconds) {
      LinkRedisClient jedis = null;

      try {
         List<String> keys = Collections.singletonList(key);
         List<String> argv = Arrays.asList(String.valueOf(expireSeconds));
         jedis = RedisUtil.getJedis();
         Long sequnce = (Long)jedis.eval("local key = KEYS[1]\nlocal expire_time = tonumber(ARGV[1])\nlocal is_exists = redis.call(\"EXISTS\", key)\nif is_exists == 1 then\n\tlocal next = tonumber(redis.call(\"INCR\", key))\n\treturn next\nelse\n\tredis.call(\"SET\", key, 1)\n\tredis.call(\"EXPIRE\", key, expire_time)\n\treturn 1\nend", keys, argv);
         Long var6 = sequnce;
         return var6;
      } catch (Exception var10) {
         Exception e = var10;
         LCLogger.error().withMessage(e.getMessage()).flush();
      } finally {
         RedisUtil.returnResource(jedis);
      }

      return -1L;
   }
}
